<script type="text/html" data-help-name="dim-xml-dataset-client">
  <style>
    tr:nth-child(even) {background-color: #f8f8f8;}
    tr:nth-child(odd) {background-color: #e8e8e8;}
  </style>
  <p>
    A DIM-XML Client node to subscribe a DataSet service on a DIM Service
    Provider (DIS). This node is used to get a set of data.
  </p>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">array</span></dt>
    <dd>The service value received.</dd>
    <dt class="optional">
      timestamp<span class="property-type">number</span>
    </dt>
    <dd>The value's UNIX timestamp in millisecs.</dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node must be configured with the name of the service to be subscribed
    to and a connection to the the DIM Name Server (DNS) hosting that service.
    For the latter, it is possible to either create a new DNS Server connection
    by clicking on the pencil icon or use an existing one shared between
    several DIM-XML nodes.
  </p>
  <p>
    The node can retrieve the list of the <i>DataSet</i> services registered on
    the DNS Server set-up.
  </p>
  <p>
    The received service value consists of an array of <i>data</i> elements,
    saved in the output <code>payload</code> property. A data element is an
    object with these properties:
    <ul>
      <li>
        <code>name</code>, an optional string that describes the data;
      </li>
      <li>
        <code>index</code>, an integer to uniquely indentify the data within
        the data set;
      </li>
      <li>
        <code>unit</code>, an optional string describing the value's unit;
      </li>
      <li>
        <code>type</code>, an integer matching one of the following:
        <table style="outline-width:#888 solid thin;text-align:left">
          <tr style="background-color: #e6e6e6;">
            <th width="50px">Type</th><th width="60px">Value</th>
          </tr>
          <tr><td>1</td><td>int32</td></tr>
          <tr><td>2</td><td>double</td></tr>
          <tr><td>3</td><td>string</td></tr>
          <tr><td>4</td><td>int64</td></tr>
          <tr><td>5</td><td>enum</td></tr>
          <tr><td>6</td><td>int8</td></tr>
          <tr><td>7</td><td>int16</td></tr>
          <tr><td>8</td><td>float</td></tr>
          <tr><td>9</td><td>bool</td></tr>
          <tr><td>11</td><td>uint32</td></tr>
          <tr><td>14</td><td>uint64</td></tr>
          <tr><td>16</td><td>uint8</td></tr>
          <tr><td>17</td><td>uint16</td></tr>
        </table>
      </li>
      <li>
        <code>value</code>, the data value.
      </li>
    </ul>
    Furthermore, <i>enum</i> data have two additional properties:
    <ul>
      <li>
        <code>enum</code>, the list of all possible values that can be
        assigned to the data;
      </li>
      <li>
        <code>valueName</code>, the name associated with the selected value.
      </li>
    </ul>
    If the data have no type, it is a <i>nested</i> dataset, that is the
    <code>value</code> property can contain data child elements such as those
    described above.
  </p>
  <p>
    By default, the node is configured to retrieve the service value manually,
    by clicking on its button within the editor. It can also be set to monitor
    a value, get the value with a given schedule or both. In particular, with
    the option:
    <ul>
      <li><b>Monitored</b>, if enabled, the node receives a service value when
        updated server side.
      <li><b>Scheduled</b>, if enabled, the node receives a service value at a
        regular time intervals defined by the <i>Every</i> field. The time
        interval is equal to 1000 millisecs by default.
    </ul>
  </p>
  <p>
    The first service value is received upon subscription, which is the current
    service value or a <i>null</i> one if it is not set.
  </p>
  <p>
    It is also possible to request service values with additional timestamp
    information by selecting the <b>Stamped</b> option. Thus, the value's
    timestamp is saved in the <code>msg.timestamp</code> property.
  </p>
</script>
